/******************************************************************************
Copyright 2007 
All rights reserved.

ļ  .c
ģƣst7920 зʽ12864Һ
ܸҪst7920ʾ
ڣ2007.07.08
оƬst7920
******************************************************************************/
#include <reg52.h>

#define uint  unsigned int
#define uchar unsigned char
#define x1    0x80
#define x2    0x88
#define y     0x80
#define comm  0
#define dat   1

sbit RS = P3^0;   //H=data; L="command";
sbit RW = P3^1;   //H=read; L="write";
sbit  E = P3^2;   //input enable;
sbit PSB= P3^3;   //H=; L="";
sbit RST= P3^5;   //Reset Signal ͵ƽЧ

sbit busy=P0^7;   //lcd busy bit

void wr_lcd (uchar dat_comm,uchar content);
void chk_busy (void);
void delay (uint us);

uchar code tab1[]={
"ӭʹ"
"ʵ幦ܳǿ"
"ӵSY-51PRO๦"
"ѧϰƬѡ"
};

uchar code tab31[]={
"ӭ"
"WWW.RISUM.COM"
};



/******************************************************************************************
*     
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void init_lcd (void)
{
   RST = 1;
   PSB = 1;
   wr_lcd(comm,0x30);  /*30---ָ*/   
   wr_lcd(comm,0x01);  /*ַָָ00H*/
   wr_lcd(comm,0x06);  /*ƶ*/
   wr_lcd(comm,0x0c);  /*ʾα*/
}

/******************************************************************************************
*     chn_disp
*      ʾַֻ
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void chn_disp(uchar code *chn)
{
   uchar i,j;
   wr_lcd(comm,0x30);
   wr_lcd(comm,0x80);
   for(j=0;j<4;j++)
   {
     for(i=0;i<16;i++)
     wr_lcd(dat,chn[j*16+i]);
   }
}

/******************************************************************************************
*     chn_disp1
*      ϰʾַֻ
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void chn_disp1(uchar code *chn)
{
   uchar i,j;
   wr_lcd(comm,0x30);
   wr_lcd(comm,0x80);
   j=0;
   for(i=0;i<16;i++)
   wr_lcd(dat,chn[j*16+i]);
   wr_lcd(comm,0x90);
   j=1;
   for(i=0;i<16;i++)
   wr_lcd(dat,chn[j*16+i]);
}

/******************************************************************************************
*     img_disp
*      ʾͼ
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void img_disp(uchar code *img)
{
   uchar i,j;
   for(j=0;j<32;j++)
   {
     for(i=0;i<8;i++)
     {
       wr_lcd(comm,0x34);
       wr_lcd(comm,y+j);
       wr_lcd(comm,x1+i);
       wr_lcd(comm,0x30);
       wr_lcd(dat,img[j*16+i*2]);
       wr_lcd(dat,img[j*16+i*2+1]);
     }
   }
   for(j=32;j<64;j++)
   {
     for(i=0;i<8;i++)
     {
       wr_lcd(comm,0x34);
       wr_lcd(comm,y+j-32);
       wr_lcd(comm,x2+i);
       wr_lcd(comm,0x30);
       wr_lcd(dat,img[j*16+i*2]);
       wr_lcd(dat,img[j*16+i*2+1]);
     }
   }
   wr_lcd (comm,0x36);
}

/******************************************************************************************
*     img_disp1
*      °ʾͼ
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void img_disp1(uchar code *img)
{
   uchar i,j;
   for(j=0;j<32;j++)
   {
     for(i=0;i<8;i++)
     {
       wr_lcd(comm,0x34);
       wr_lcd(comm,y+j);
       wr_lcd(comm,x2+i);
       wr_lcd(comm,0x30);
       wr_lcd(dat,img[j*16+i*2]);
       wr_lcd(dat,img[j*16+i*2+1]);
     }
   }
   wr_lcd(comm,0x36);
}

/******************************************************************************************
*     lat_disp
*      ʾ
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void lat_disp(uchar data1,uchar data2)
{
   uchar i,j,k,x;
   x=x1;
   for(k=0;k<2;k++)
   {
     for(j=0;j<16;j++)
     {
       for(i=0;i<8;i++)
       {
         wr_lcd(comm,0x34);
          wr_lcd(comm,y+j*2);
         wr_lcd(comm,x+i);
         wr_lcd(comm,0x30);
         wr_lcd(dat,data1);
         wr_lcd(dat,data1);
       }
       for(i=0;i<8;i++)
       {
         wr_lcd(comm,0x34);
         wr_lcd(comm,y+j*2+1);
         wr_lcd(comm,x+i);
         wr_lcd(comm,0x30);
         wr_lcd(dat,data2);
         wr_lcd(dat,data2);
       }
     }
     x=x2;
   }
   wr_lcd(comm,0x36);
}

/******************************************************************************************
*     con_disp
*      data1=0xff,data2=0xffʱ,x0,y0ʾ16xl*yl
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void con_disp(uchar data1,uchar data2,uchar x0,uchar y0,uchar xl,uchar yl)
{
   uchar i,j;
   for(j=0;j<yl;j++)
   {
     for(i=0;i<xl;i++)
     {
       wr_lcd(comm,0x34);
       wr_lcd(comm,y0+j);
       wr_lcd(comm,x0+i);
       wr_lcd(comm,0x30);
       wr_lcd(dat,data1);
       wr_lcd(dat,data2);
     }
   }
   wr_lcd(comm,0x36);
}

/******************************************************************************************
*     clrram
*      DDRAM
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void clrram(void)
{
   wr_lcd(comm,0x30);
   wr_lcd(comm,0x01);
}

/******************************************************************************************
*     wr_lcd
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void wr_lcd(uchar dat_comm,uchar content)
{
   chk_busy ();
   if(dat_comm)
    {
     RS = 1;   //data
     RW = 0;   //write
    }
   else 
    {
     RS = 0;   //command
     RW = 0;   //write
    }
   P0=content;   //output data or comm
   E = 1;
   ;
   E = 0;
}
/******************************************************************************************
*     chk_busy
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void chk_busy(void)
{
   P0 = 0xff;
   RS = 0;
   RW = 1;
   E = 1;
   while(busy==1);
   E = 0;
}
/******************************************************************************************
*     
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void delay(uint us)   //delay time
{
   while(us--);
}
/******************************************************************************************
*     
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void delay1(uint ms)
{
   uint i,j;
   for(i=0;i<ms;i++)
   for(j=0;j<15;j++)
   delay(1);
}

/******************************************************************************************
*     
*      
*           ƣ /   
* 
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
void main()
{
   SP=0x5f;
   init_lcd();
   while(1)
   {
     lat_disp(0x00,0x00);
     chn_disp(tab1);
     con_disp(0xff,0xff,0x8c,0x80,2,16);
     delay1(8000);
     clrram();
     //lat_disp(0xcc,0xcc);
     //delay1(8000);
     lat_disp(0x00,0x00);
     chn_disp1(tab31);
     
     delay1 (8000);
     clrram();
     //lat_disp (0xff,0x00);
    //delay1(8000);
    
     delay1(8000);
   }
}


